--Easy Scrapper by Motig
LoadAddOn("Blizzard_ScrappingMachineUI")
ScrappingMachineFrame.ScrapButton.SetEnabledBackup = ScrappingMachineFrame.ScrapButton.SetEnabled --To prevent button mashers from scrapping while adding items

EasyScrap = {}
EasyScrap.addonVersion = 34
EasyScrap.saveData = {}
EasyScrap.debugMode = false

EasyScrap.itemCache = {}
EasyScrap.scrappableItems = {}
EasyScrap.eligibleItems = {}
EasyScrap.ignoredItems = {}
EasyScrap.filteredItems = {}
EasyScrap.queueItems = {}
EasyScrap.itemsInScrapper = {}
EasyScrap.failedItems = {}
EasyScrap.queueItemsToAdd = 0
EasyScrap.scrapInProgress = false
EasyScrap.itemIgnoreList = {}
EasyScrap.mouseInItem = false
EasyScrap.mouseInItemRef = 0
EasyScrap.activeFilterID = 0

EasyScrap.defaultSettings = {}
EasyScrap.defaultSettings.defaultFilter = 0
EasyScrap.defaultSettings.canScrapTooltip = false

EasyScrap.defaultFilter = {}
EasyScrap.defaultFilter.name = 'Default'
EasyScrap.defaultFilter.rules = {{["filterType"] = "equipmentSet",}}

function EasyScrap:initializeSaveData()
    self.saveData = {}
    self.saveData.addonSettings = EasyScrap.defaultSettings
    self.saveData.showWhatsNew = nil
    self.saveData.customFilters = {}
    --self.saveData.addonVersion = EasyScrap.addonVersion
end

function EasyScrap:updateAddonSettings()
    for k,v in pairs(EasyScrap.defaultSettings) do
        if self.saveData.addonSettings[k] == nil then self.saveData.addonSettings[k] = v end
    end
end

BINDING_HEADER_EASYSCRAPHEAD = "Easy Scrap"
_G["BINDING_NAME_CLICK EasyScrap_ScrapKeybindFrame:LeftButton"] = "Scrap Item"

local keybindFrame = CreateFrame('Button', 'EasyScrap_ScrapKeybindFrame', nil, 'SecureActionButtonTemplate')
keybindFrame:SetAttribute('type', 'click')
keybindFrame:SetAttribute('clickbutton', ScrappingMachineFrame.ScrapButton)
keybindFrame:RegisterForClicks("AnyUp", "AnyDown")

--Interface\HelpFrame\HelpIcon-ReportAbuse

--[[
GameTooltip:HookScript('OnTooltipSetItem', function(self)
      if EasyScrap.saveData.addonSettings.canScrapTooltip and not ScrappingMachineFrame:IsVisible() then
         local _, itemLink = self:GetItem()
         if itemLink then
             local itemID = string.match(itemLink, 'Hitem:(%d+):')
             if EasyScrap.scrappableItemDB[tonumber(itemID)] then
                GameTooltip:AddLine(ITEM_SCRAPABLE, 0.53333216905594, 0.66666519641876, 0.99999779462814)
             end 
         end
      end

  --Ugly hack to deal with addons that are redrawing tooltips?
    if EasyScrap.mouseInItemRef > 0 and ScrappingMachineFrame:IsVisible() then 
        if EasyScrap.scrappableItems[EasyScrap.mouseInItemRef].filterMessage and not EasyScrap:itemInIgnoreList(EasyScrap.mouseInItemRef) then
            GameTooltip:AddLine('|cFFFF0000'..EasyScrap.scrappableItems[EasyScrap.mouseInItemRef].filterMessage..'|r') 
        end
        if IsModifiedClick("COMPAREITEMS") then
            GameTooltip_ShowCompareItem(GameTooltip);
        end
    end      
end)
--]]

EasyScrap.scrappableItemDB = {
		[159217] = true,
		[164336] = true,
		[158706] = true,
		[159218] = true,
		[164337] = true,
		[159219] = true,
		[164338] = true,
		[159220] = true,
		[164339] = true,
		[161268] = true,
		[155126] = true,
		[164340] = true,
		[161269] = true,
		[158710] = true,
		[159222] = true,
		[164341] = true,
		[161270] = true,
		[158711] = true,
		[159223] = true,
		[164342] = true,
		[161271] = true,
		[158712] = true,
		[164343] = true,
		[161272] = true,
		[158713] = true,
		[155130] = true,
		[164344] = true,
		[161273] = true,
		[158714] = true,
		[159226] = true,
		[164345] = true,
		[161274] = true,
		[159227] = true,
		[164346] = true,
		[161275] = true,
		[159228] = true,
		[164347] = true,
		[161276] = true,
		[159229] = true,
		[161277] = true,
		[159230] = true,
		[164349] = true,
		[161278] = true,
		[159231] = true,
		[164350] = true,
		[161279] = true,
		[159232] = true,
		[164351] = true,
		[161280] = true,
		[159233] = true,
		[164352] = true,
		[161281] = true,
		[159234] = true,
		[164353] = true,
		[161282] = true,
		[159235] = true,
		[164354] = true,
		[161283] = true,
		[159236] = true,
		[164355] = true,
		[161284] = true,
		[162308] = true,
		[159237] = true,
		[160261] = true,
		[161285] = true,
		[162309] = true,
		[159238] = true,
		[160262] = true,
		[161286] = true,
		[158215] = true,
		[159239] = true,
		[160263] = true,
		[161287] = true,
		[158216] = true,
		[159240] = true,
		[164359] = true,
		[161288] = true,
		[159241] = true,
		[164360] = true,
		[161289] = true,
		[158218] = true,
		[159242] = true,
		[164361] = true,
		[161290] = true,
		[158219] = true,
		[159243] = true,
		[160267] = true,
		[161291] = true,
		[158220] = true,
		[159244] = true,
		[164363] = true,
		[161292] = true,
		[159245] = true,
		[160269] = true,
		[161293] = true,
		[163341] = true,
		[159247] = true,
		[164366] = true,
		[158224] = true,
		[155153] = true,
		[161296] = true,
		[158225] = true,
		[163344] = true,
		[161297] = true,
		[159250] = true,
		[161298] = true,
		[159251] = true,
		[159763] = true,
		[161299] = true,
		[158228] = true,
		[159252] = true,
		[159764] = true,
		[161300] = true,
		[158229] = true,
		[159253] = true,
		[159765] = true,
		[161301] = true,
		[158230] = true,
		[159254] = true,
		[161302] = true,
		[158231] = true,
		[159255] = true,
		[163862] = true,
		[161303] = true,
		[158232] = true,
		[159256] = true,
		[163863] = true,
		[161304] = true,
		[158233] = true,
		[159257] = true,
		[163864] = true,
		[161305] = true,
		[158234] = true,
		[155163] = true,
		[163865] = true,
		[158235] = true,
		[159259] = true,
		[163866] = true,
		[158236] = true,
		[159260] = true,
		[163867] = true,
		[161308] = true,
		[158237] = true,
		[155166] = true,
		[163868] = true,
		[161309] = true,
		[154143] = true,
		[159262] = true,
		[163869] = true,
		[161310] = true,
		[158239] = true,
		[159263] = true,
		[163870] = true,
		[161311] = true,
		[158240] = true,
		[155169] = true,
		[163871] = true,
		[164383] = true,
		[158241] = true,
		[159265] = true,
		[163872] = true,
		[164384] = true,
		[158242] = true,
		[155171] = true,
		[163873] = true,
		[164385] = true,
		[158243] = true,
		[159267] = true,
		[163874] = true,
		[164386] = true,
		[153637] = true,
		[158244] = true,
		[159268] = true,
		[163875] = true,
		[164387] = true,
		[153638] = true,
		[158245] = true,
		[155174] = true,
		[163876] = true,
		[164388] = true,
		[153639] = true,
		[158246] = true,
		[159270] = true,
		[163877] = true,
		[164389] = true,
		[153640] = true,
		[158247] = true,
		[154664] = true,
		[155176] = true,
		[163878] = true,
		[164390] = true,
		[158248] = true,
		[159272] = true,
		[163879] = true,
		[164391] = true,
		[158249] = true,
		[159273] = true,
		[163880] = true,
		[164392] = true,
		[153643] = true,
		[158250] = true,
		[155179] = true,
		[163881] = true,
		[164393] = true,
		[158251] = true,
		[159275] = true,
		[163882] = true,
		[164394] = true,
		[158252] = true,
		[155181] = true,
		[163883] = true,
		[164395] = true,
		[158253] = true,
		[159277] = true,
		[163884] = true,
		[164396] = true,
		[158254] = true,
		[159278] = true,
		[163885] = true,
		[164397] = true,
		[158255] = true,
		[159279] = true,
		[163886] = true,
		[164398] = true,
		[154161] = true,
		[159280] = true,
		[163887] = true,
		[164399] = true,
		[154162] = true,
		[162864] = true,
		[155186] = true,
		[163888] = true,
		[164400] = true,
		[158258] = true,
		[162865] = true,
		[159282] = true,
		[163889] = true,
		[164401] = true,
		[158259] = true,
		[162866] = true,
		[155188] = true,
		[163890] = true,
		[164402] = true,
		[158260] = true,
		[162867] = true,
		[159284] = true,
		[163891] = true,
		[164403] = true,
		[158261] = true,
		[162868] = true,
		[159285] = true,
		[159797] = true,
		[164404] = true,
		[158262] = true,
		[162869] = true,
		[155191] = true,
		[159798] = true,
		[164405] = true,
		[152632] = true,
		[158263] = true,
		[162870] = true,
		[159287] = true,
		[159799] = true,
		[164406] = true,
		[158264] = true,
		[162871] = true,
		[155193] = true,
		[159800] = true,
		[164407] = true,
		[152634] = true,
		[158265] = true,
		[162872] = true,
		[159289] = true,
		[164408] = true,
		[158266] = true,
		[162873] = true,
		[155195] = true,
		[159802] = true,
		[164409] = true,
		[152636] = true,
		[158267] = true,
		[162874] = true,
		[155196] = true,
		[159803] = true,
		[164410] = true,
		[152637] = true,
		[158268] = true,
		[154685] = true,
		[155197] = true,
		[159804] = true,
		[164411] = true,
		[158269] = true,
		[154686] = true,
		[159293] = true,
		[159805] = true,
		[164412] = true,
		[158270] = true,
		[154687] = true,
		[159294] = true,
		[159806] = true,
		[164413] = true,
		[158271] = true,
		[154688] = true,
		[159295] = true,
		[159807] = true,
		[164414] = true,
		[158272] = true,
		[154689] = true,
		[159808] = true,
		[164415] = true,
		[158273] = true,
		[154690] = true,
		[159297] = true,
		[159809] = true,
		[164416] = true,
		[158274] = true,
		[154691] = true,
		[159298] = true,
		[159810] = true,
		[164417] = true,
		[158275] = true,
		[154692] = true,
		[155204] = true,
		[159811] = true,
		[164418] = true,
		[158276] = true,
		[154693] = true,
		[159300] = true,
		[159812] = true,
		[164419] = true,
		[158277] = true,
		[154694] = true,
		[159301] = true,
		[159813] = true,
		[164420] = true,
		[161349] = true,
		[158278] = true,
		[162885] = true,
		[159302] = true,
		[164421] = true,
		[161350] = true,
		[158279] = true,
		[162886] = true,
		[159303] = true,
		[164422] = true,
		[161351] = true,
		[158280] = true,
		[154697] = true,
		[155209] = true,
		[159816] = true,
		[164423] = true,
		[161352] = true,
		[158281] = true,
		[162888] = true,
		[155210] = true,
		[164424] = true,
		[161353] = true,
		[158282] = true,
		[162889] = true,
		[155211] = true,
		[159818] = true,
		[164425] = true,
		[161354] = true,
		[158283] = true,
		[154700] = true,
		[159307] = true,
		[159819] = true,
		[160331] = true,
		[161355] = true,
		[158284] = true,
		[162891] = true,
		[159308] = true,
		[159820] = true,
		[160332] = true,
		[161356] = true,
		[158285] = true,
		[162892] = true,
		[159309] = true,
		[159821] = true,
		[160333] = true,
		[161357] = true,
		[158286] = true,
		[162893] = true,
		[159310] = true,
		[159822] = true,
		[160334] = true,
		[156751] = true,
		[161358] = true,
		[158287] = true,
		[162894] = true,
		[155216] = true,
		[159823] = true,
		[160335] = true,
		[156752] = true,
		[161359] = true,
		[158288] = true,
		[162895] = true,
		[155217] = true,
		[159824] = true,
		[160336] = true,
		[156753] = true,
		[161360] = true,
		[158289] = true,
		[162896] = true,
		[159313] = true,
		[160337] = true,
		[156754] = true,
		[161361] = true,
		[153683] = true,
		[158290] = true,
		[162897] = true,
		[159314] = true,
		[160338] = true,
		[156755] = true,
		[161362] = true,
		[153684] = true,
		[158291] = true,
		[162898] = true,
		[163410] = true,
		[160339] = true,
		[161363] = true,
		[153685] = true,
		[162899] = true,
		[155221] = true,
		[160340] = true,
		[161364] = true,
		[153686] = true,
		[162900] = true,
		[159317] = true,
		[160341] = true,
		[161365] = true,
		[153687] = true,
		[158294] = true,
		[162901] = true,
		[155223] = true,
		[163925] = true,
		[160342] = true,
		[161366] = true,
		[153688] = true,
		[158295] = true,
		[162902] = true,
		[155224] = true,
		[163926] = true,
		[160343] = true,
		[161367] = true,
		[153689] = true,
		[158296] = true,
		[162903] = true,
		[159320] = true,
		[163927] = true,
		[160344] = true,
		[161368] = true,
		[153690] = true,
		[158297] = true,
		[162904] = true,
		[155226] = true,
		[163928] = true,
		[160345] = true,
		[161369] = true,
		[161881] = true,
		[158298] = true,
		[162905] = true,
		[159322] = true,
		[160346] = true,
		[160858] = true,
		[161370] = true,
		[161882] = true,
		[158299] = true,
		[162906] = true,
		[159323] = true,
		[160347] = true,
		[160859] = true,
		[161371] = true,
		[161883] = true,
		[162395] = true,
		[162907] = true,
		[159324] = true,
		[163931] = true,
		[160348] = true,
		[160860] = true,
		[161372] = true,
		[161884] = true,
		[158301] = true,
		[162908] = true,
		[159325] = true,
		[163932] = true,
		[160349] = true,
		[160861] = true,
		[161885] = true,
		[158302] = true,
		[162909] = true,
		[155231] = true,
		[163933] = true,
		[160350] = true,
		[161886] = true,
		[158303] = true,
		[162910] = true,
		[159327] = true,
		[163934] = true,
		[160351] = true,
		[164570] = true,
		[164569] = true,
		[161887] = true,
		[158304] = true,
		[162911] = true,
		[159328] = true,
		[159840] = true,
		[160352] = true,
		[164568] = true,
		[161376] = true,
		[161888] = true,
		[158305] = true,
		[162912] = true,
		[159329] = true,
		[163936] = true,
		[160353] = true,
		[164567] = true,
		[161377] = true,
		[161889] = true,
		[158306] = true,
		[162913] = true,
		[155235] = true,
		[163937] = true,
		[160354] = true,
		[164566] = true,
		[161378] = true,
		[161890] = true,
		[158307] = true,
		[162914] = true,
		[159331] = true,
		[163938] = true,
		[160355] = true,
		[164565] = true,
		[161379] = true,
		[161891] = true,
		[158308] = true,
		[162915] = true,
		[159332] = true,
		[163939] = true,
		[160356] = true,
		[164564] = true,
		[161380] = true,
		[161892] = true,
		[158309] = true,
		[162916] = true,
		[159333] = true,
		[163940] = true,
		[160357] = true,
		[163301] = true,
		[161381] = true,
		[161893] = true,
		[162405] = true,
		[162917] = true,
		[159334] = true,
		[163941] = true,
		[160358] = true,
		[164562] = true,
		[164561] = true,
		[161894] = true,
		[158311] = true,
		[162918] = true,
		[159335] = true,
		[163942] = true,
		[160359] = true,
		[164560] = true,
		[164559] = true,
		[161895] = true,
		[154217] = true,
		[162919] = true,
		[155241] = true,
		[163943] = true,
		[160360] = true,
		[164558] = true,
		[164557] = true,
		[161896] = true,
		[158313] = true,
		[162920] = true,
		[159337] = true,
		[163944] = true,
		[160361] = true,
		[164556] = true,
		[164555] = true,
		[161897] = true,
		[158314] = true,
		[162921] = true,
		[159338] = true,
		[163945] = true,
		[160362] = true,
		[164554] = true,
		[164553] = true,
		[161898] = true,
		[158315] = true,
		[162922] = true,
		[159339] = true,
		[159851] = true,
		[160363] = true,
		[164552] = true,
		[161387] = true,
		[161899] = true,
		[162411] = true,
		[162923] = true,
		[155245] = true,
		[163947] = true,
		[160364] = true,
		[164551] = true,
		[161388] = true,
		[164550] = true,
		[158317] = true,
		[162924] = true,
		[155246] = true,
		[159853] = true,
		[160365] = true,
		[160877] = true,
		[161389] = true,
		[164549] = true,
		[158318] = true,
		[162925] = true,
		[155247] = true,
		[163949] = true,
		[160366] = true,
		[160878] = true,
		[161390] = true,
		[161902] = true,
		[158319] = true,
		[162926] = true,
		[159343] = true,
		[159855] = true,
		[160367] = true,
		[160879] = true,
		[161391] = true,
		[163306] = true,
		[158320] = true,
		[162927] = true,
		[159344] = true,
		[163951] = true,
		[160368] = true,
		[160880] = true,
		[161392] = true,
		[163436] = true,
		[158321] = true,
		[162928] = true,
		[159345] = true,
		[159857] = true,
		[160369] = true,
		[164546] = true,
		[161393] = true,
		[164545] = true,
		[158322] = true,
		[162929] = true,
		[155251] = true,
		[159858] = true,
		[160370] = true,
		[164544] = true,
		[161394] = true,
		[161906] = true,
		[158323] = true,
		[162930] = true,
		[159347] = true,
		[163954] = true,
		[160371] = true,
		[163441] = true,
		[161395] = true,
		[161907] = true,
		[164542] = true,
		[162931] = true,
		[155253] = true,
		[159860] = true,
		[160372] = true,
		[163444] = true,
		[161396] = true,
		[155249] = true,
		[155250] = true,
		[162932] = true,
		[155254] = true,
		[159861] = true,
		[160373] = true,
		[160885] = true,
		[161397] = true,
		[163452] = true,
		[159357] = true,
		[162933] = true,
		[155255] = true,
		[163957] = true,
		[160374] = true,
		[163459] = true,
		[161398] = true,
		[163461] = true,
		[163596] = true,
		[162934] = true,
		[155256] = true,
		[159863] = true,
		[160375] = true,
		[160887] = true,
		[161399] = true,
		[163310] = true,
		[163893] = true,
		[162935] = true,
		[155257] = true,
		[163959] = true,
		[160376] = true,
		[160888] = true,
		[161400] = true,
		[163935] = true,
		[163950] = true,
		[162936] = true,
		[155258] = true,
		[159865] = true,
		[160377] = true,
		[160889] = true,
		[161401] = true,
		[161913] = true,
		[158330] = true,
		[162937] = true,
		[155259] = true,
		[159866] = true,
		[160378] = true,
		[160890] = true,
		[161402] = true,
		[161914] = true,
		[163956] = true,
		[162938] = true,
		[155260] = true,
		[163962] = true,
		[160379] = true,
		[163961] = true,
		[161403] = true,
		[161915] = true,
		[164268] = true,
		[162939] = true,
		[155261] = true,
		[163963] = true,
		[160380] = true,
		[164272] = true,
		[161404] = true,
		[161916] = true,
		[164276] = true,
		[162940] = true,
		[155262] = true,
		[164280] = true,
		[160381] = true,
		[164284] = true,
		[161405] = true,
		[161917] = true,
		[164288] = true,
		[162941] = true,
		[155263] = true,
		[163965] = true,
		[160382] = true,
		[164294] = true,
		[161406] = true,
		[161918] = true,
		[164298] = true,
		[162942] = true,
		[155264] = true,
		[163966] = true,
		[160383] = true,
		[159502] = true,
		[161407] = true,
		[161919] = true,
		[162431] = true,
		[162943] = true,
		[155265] = true,
		[163967] = true,
		[160384] = true,
		[164307] = true,
		[161408] = true,
		[161920] = true,
		[162432] = true,
		[162944] = true,
		[155266] = true,
		[163968] = true,
		[160385] = true,
		[162408] = true,
		[161409] = true,
		[161921] = true,
		[158338] = true,
		[162945] = true,
		[155267] = true,
		[163969] = true,
		[160386] = true,
		[162504] = true,
		[163345] = true,
		[161922] = true,
		[162434] = true,
		[162946] = true,
		[155268] = true,
		[159407] = true,
		[160387] = true,
		[159425] = true,
		[161411] = true,
		[161923] = true,
		[162435] = true,
		[162947] = true,
		[155269] = true,
		[164358] = true,
		[160388] = true,
		[164427] = true,
		[161412] = true,
		[161924] = true,
		[158341] = true,
		[162948] = true,
		[155270] = true,
		[164431] = true,
		[160389] = true,
		[164435] = true,
		[164439] = true,
		[161925] = true,
		[162437] = true,
		[162949] = true,
		[155271] = true,
		[164444] = true,
		[160390] = true,
		[164448] = true,
		[164453] = true,
		[161926] = true,
		[162438] = true,
		[162950] = true,
		[155272] = true,
		[164456] = true,
		[160391] = true,
		[164459] = true,
		[164461] = true,
		[161927] = true,
		[158344] = true,
		[162951] = true,
		[159368] = true,
		[164465] = true,
		[160392] = true,
		[164468] = true,
		[164470] = true,
		[161928] = true,
		[158345] = true,
		[162952] = true,
		[159369] = true,
		[164472] = true,
		[160393] = true,
		[164474] = true,
		[164479] = true,
		[164481] = true,
		[158346] = true,
		[162953] = true,
		[159370] = true,
		[164484] = true,
		[160394] = true,
		[160906] = true,
		[164486] = true,
		[161930] = true,
		[158347] = true,
		[162954] = true,
		[159371] = true,
		[164489] = true,
		[160395] = true,
		[160907] = true,
		[161419] = true,
		[161931] = true,
		[158348] = true,
		[162955] = true,
		[159372] = true,
		[159884] = true,
		[160396] = true,
		[160908] = true,
		[164491] = true,
		[164490] = true,
		[158349] = true,
		[162956] = true,
		[155278] = true,
		[159885] = true,
		[164492] = true,
		[160909] = true,
		[164488] = true,
		[164487] = true,
		[158350] = true,
		[162957] = true,
		[159374] = true,
		[159886] = true,
		[164493] = true,
		[160910] = true,
		[164485] = true,
		[161934] = true,
		[158351] = true,
		[162958] = true,
		[159375] = true,
		[159887] = true,
		[164494] = true,
		[160911] = true,
		[164483] = true,
		[164482] = true,
		[162447] = true,
		[162959] = true,
		[159376] = true,
		[159888] = true,
		[164495] = true,
		[160912] = true,
		[164480] = true,
		[161936] = true,
		[158353] = true,
		[162960] = true,
		[159377] = true,
		[159889] = true,
		[164496] = true,
		[160913] = true,
		[164478] = true,
		[164477] = true,
		[164476] = true,
		[162961] = true,
		[164475] = true,
		[159890] = true,
		[164497] = true,
		[160914] = true,
		[164473] = true,
		[161938] = true,
		[158355] = true,
		[162962] = true,
		[159379] = true,
		[159891] = true,
		[164498] = true,
		[160915] = true,
		[164471] = true,
		[161939] = true,
		[158356] = true,
		[162963] = true,
		[159380] = true,
		[159892] = true,
		[164499] = true,
		[160916] = true,
		[164469] = true,
		[161940] = true,
		[158357] = true,
		[162964] = true,
		[159381] = true,
		[159893] = true,
		[164500] = true,
		[160917] = true,
		[164467] = true,
		[161941] = true,
		[162453] = true,
		[162965] = true,
		[159382] = true,
		[164466] = true,
		[164501] = true,
		[160918] = true,
		[164464] = true,
		[161942] = true,
		[158359] = true,
		[162966] = true,
		[164463] = true,
		[164462] = true,
		[164502] = true,
		[160919] = true,
		[164460] = true,
		[161943] = true,
		[158360] = true,
		[162967] = true,
		[159384] = true,
		[159896] = true,
		[164503] = true,
		[160920] = true,
		[164458] = true,
		[161944] = true,
		[158361] = true,
		[162968] = true,
		[159385] = true,
		[164457] = true,
		[164504] = true,
		[160921] = true,
		[164455] = true,
		[161945] = true,
		[158362] = true,
		[162969] = true,
		[159386] = true,
		[164454] = true,
		[164505] = true,
		[164452] = true,
		[164451] = true,
		[161946] = true,
		[158363] = true,
		[162970] = true,
		[164450] = true,
		[164449] = true,
		[164506] = true,
		[164447] = true,
		[164446] = true,
		[161947] = true,
		[158364] = true,
		[162971] = true,
		[159388] = true,
		[164445] = true,
		[164507] = true,
		[164443] = true,
		[164442] = true,
		[161948] = true,
		[164441] = true,
		[164440] = true,
		[159389] = true,
		[159901] = true,
		[164508] = true,
		[164438] = true,
		[164437] = true,
		[161949] = true,
		[158366] = true,
		[164436] = true,
		[159390] = true,
		[159902] = true,
		[164509] = true,
		[164434] = true,
		[164433] = true,
		[161950] = true,
		[158367] = true,
		[164432] = true,
		[159391] = true,
		[159903] = true,
		[164510] = true,
		[164430] = true,
		[164429] = true,
		[161951] = true,
		[158368] = true,
		[164428] = true,
		[159392] = true,
		[159904] = true,
		[164511] = true,
		[164426] = true,
		[164364] = true,
		[161952] = true,
		[158369] = true,
		[164362] = true,
		[159393] = true,
		[159905] = true,
		[164512] = true,
		[164357] = true,
		[164356] = true,
		[161953] = true,
		[158370] = true,
		[155287] = true,
		[155299] = true,
		[159906] = true,
		[164513] = true,
		[159354] = true,
		[159367] = true,
		[161954] = true,
		[158371] = true,
		[155243] = true,
		[159395] = true,
		[159907] = true,
		[164514] = true,
		[163380] = true,
		[159423] = true,
		[161955] = true,
		[162467] = true,
		[163355] = true,
		[159396] = true,
		[159908] = true,
		[164515] = true,
		[159428] = true,
		[161444] = true,
		[161956] = true,
		[158373] = true,
		[163403] = true,
		[159397] = true,
		[162890] = true,
		[164516] = true,
		[159415] = true,
		[162469] = true,
		[161957] = true,
		[158374] = true,
		[162459] = true,
		[159398] = true,
		[162439] = true,
		[164517] = true,
		[162398] = true,
		[161446] = true,
		[161958] = true,
		[158375] = true,
		[162353] = true,
		[155304] = true,
		[162324] = true,
		[164518] = true,
		[161967] = true,
		[159437] = true,
		[161959] = true,
		[162471] = true,
		[155079] = true,
		[159400] = true,
		[159912] = true,
		[164519] = true,
		[164302] = true,
		[155476] = true,
		[161960] = true,
		[162472] = true,
		[162617] = true,
		[164299] = true,
		[159913] = true,
		[164520] = true,
		[164297] = true,
		[164296] = true,
		[161961] = true,
		[162473] = true,
		[164295] = true,
		[159402] = true,
		[159914] = true,
		[164521] = true,
		[164293] = true,
		[164292] = true,
		[161962] = true,
		[162474] = true,
		[164291] = true,
		[155308] = true,
		[159915] = true,
		[164522] = true,
		[164287] = true,
		[164286] = true,
		[161963] = true,
		[162475] = true,
		[164285] = true,
		[155309] = true,
		[159916] = true,
		[164523] = true,
		[155110] = true,
		[162665] = true,
		[161964] = true,
		[162476] = true,
		[164281] = true,
		[155310] = true,
		[159917] = true,
		[164524] = true,
		[164279] = true,
		[161453] = true,
		[161965] = true,
		[162477] = true,
		[164278] = true,
		[155311] = true,
		[164277] = true,
		[164525] = true,
		[164275] = true,
		[161454] = true,
		[157871] = true,
		[162478] = true,
		[164274] = true,
		[155312] = true,
		[164273] = true,
		[164526] = true,
		[164271] = true,
		[161455] = true,
		[157872] = true,
		[162479] = true,
		[164270] = true,
		[155313] = true,
		[164269] = true,
		[164527] = true,
		[164267] = true,
		[161456] = true,
		[157873] = true,
		[162480] = true,
		[164266] = true,
		[155314] = true,
		[164265] = true,
		[164528] = true,
		[163946] = true,
		[161457] = true,
		[157874] = true,
		[162481] = true,
		[163958] = true,
		[155315] = true,
		[159922] = true,
		[164529] = true,
		[163955] = true,
		[161458] = true,
		[157875] = true,
		[158387] = true,
		[163953] = true,
		[155316] = true,
		[163952] = true,
		[164530] = true,
		[160947] = true,
		[161459] = true,
		[157876] = true,
		[158388] = true,
		[163311] = true,
		[155317] = true,
		[155284] = true,
		[164531] = true,
		[163895] = true,
		[161460] = true,
		[157877] = true,
		[158389] = true,
		[154806] = true,
		[155318] = true,
		[163894] = true,
		[164532] = true,
		[163892] = true,
		[161461] = true,
		[157878] = true,
		[158390] = true,
		[154807] = true,
		[155319] = true,
		[155273] = true,
		[164533] = true,
		[160950] = true,
		[161462] = true,
		[157879] = true,
		[158391] = true,
		[154808] = true,
		[155320] = true,
		[163438] = true,
		[164534] = true,
		[160951] = true,
		[161463] = true,
		[157880] = true,
		[158392] = true,
		[154809] = true,
		[155321] = true,
		[163462] = true,
		[164535] = true,
		[160952] = true,
		[161464] = true,
		[157881] = true,
		[158393] = true,
		[154810] = true,
		[155322] = true,
		[163460] = true,
		[164536] = true,
		[163458] = true,
		[161465] = true,
		[157882] = true,
		[158394] = true,
		[154811] = true,
		[155323] = true,
		[163309] = true,
		[164537] = true,
		[163454] = true,
		[161466] = true,
		[157883] = true,
		[162490] = true,
		[154812] = true,
		[155324] = true,
		[163453] = true,
		[164538] = true,
		[163451] = true,
		[161467] = true,
		[157884] = true,
		[162491] = true,
		[154813] = true,
		[155325] = true,
		[163450] = true,
		[164539] = true,
		[160956] = true,
		[161468] = true,
		[157885] = true,
		[162492] = true,
		[154814] = true,
		[155326] = true,
		[163308] = true,
		[164540] = true,
		[155248] = true,
		[161469] = true,
		[157886] = true,
		[162493] = true,
		[154815] = true,
		[155327] = true,
		[163414] = true,
		[164541] = true,
		[160958] = true,
		[161470] = true,
		[157887] = true,
		[158399] = true,
		[154816] = true,
		[155328] = true,
		[163443] = true,
		[160447] = true,
		[163442] = true,
		[161471] = true,
		[157888] = true,
		[158400] = true,
		[154817] = true,
		[155329] = true,
		[159936] = true,
		[164543] = true,
		[163307] = true,
		[161472] = true,
		[157889] = true,
		[158401] = true,
		[154818] = true,
		[155330] = true,
		[159937] = true,
		[160449] = true,
		[160961] = true,
		[161473] = true,
		[157890] = true,
		[158402] = true,
		[154819] = true,
		[159426] = true,
		[163402] = true,
		[160450] = true,
		[163401] = true,
		[161474] = true,
		[157891] = true,
		[162498] = true,
		[154820] = true,
		[155332] = true,
		[159939] = true,
		[160451] = true,
		[160963] = true,
		[163400] = true,
		[157892] = true,
		[162499] = true,
		[154821] = true,
		[155333] = true,
		[159940] = true,
		[164547] = true,
		[163435] = true,
		[163434] = true,
		[157893] = true,
		[162500] = true,
		[154822] = true,
		[155334] = true,
		[163433] = true,
		[164548] = true,
		[163390] = true,
		[163389] = true,
		[157894] = true,
		[162501] = true,
		[154823] = true,
		[155335] = true,
		[159942] = true,
		[160454] = true,
		[163385] = true,
		[163428] = true,
		[157895] = true,
		[162502] = true,
		[154824] = true,
		[155336] = true,
		[163427] = true,
		[160455] = true,
		[163426] = true,
		[163425] = true,
		[157896] = true,
		[158408] = true,
		[154825] = true,
		[155337] = true,
		[163305] = true,
		[160456] = true,
		[160968] = true,
		[163423] = true,
		[157897] = true,
		[158409] = true,
		[154826] = true,
		[155338] = true,
		[163377] = true,
		[160457] = true,
		[160969] = true,
		[159419] = true,
		[157898] = true,
		[158410] = true,
		[154827] = true,
		[155339] = true,
		[163420] = true,
		[160458] = true,
		[163419] = true,
		[163418] = true,
		[157899] = true,
		[158411] = true,
		[154828] = true,
		[155340] = true,
		[163416] = true,
		[160459] = true,
		[163304] = true,
		[163362] = true,
		[157900] = true,
		[158412] = true,
		[154829] = true,
		[155341] = true,
		[163361] = true,
		[160460] = true,
		[160972] = true,
		[159427] = true,
		[157901] = true,
		[158413] = true,
		[154830] = true,
		[155342] = true,
		[163408] = true,
		[160461] = true,
		[160973] = true,
		[163406] = true,
		[157902] = true,
		[158414] = true,
		[154831] = true,
		[155343] = true,
		[163405] = true,
		[160462] = true,
		[163404] = true,
		[163303] = true,
		[157903] = true,
		[158415] = true,
		[154832] = true,
		[155344] = true,
		[163353] = true,
		[160463] = true,
		[159433] = true,
		[159434] = true,
		[157904] = true,
		[163398] = true,
		[154833] = true,
		[159440] = true,
		[163397] = true,
		[160464] = true,
		[163396] = true,
		[163394] = true,
		[157905] = true,
		[163302] = true,
		[154834] = true,
		[155346] = true,
		[163342] = true,
		[160465] = true,
		[159441] = true,
		[159442] = true,
		[157906] = true,
		[163312] = true,
		[154835] = true,
		[155347] = true,
		[163384] = true,
		[160466] = true,
		[160978] = true,
		[163383] = true,
		[157907] = true,
		[158419] = true,
		[154836] = true,
		[159443] = true,
		[155860] = true,
		[160467] = true,
		[160979] = true,
		[163382] = true,
		[157908] = true,
		[158420] = true,
		[154837] = true,
		[159444] = true,
		[155861] = true,
		[164563] = true,
		[160980] = true,
		[154850] = true,
		[157909] = true,
		[158421] = true,
		[154838] = true,
		[159445] = true,
		[155862] = true,
		[160469] = true,
		[155227] = true,
		[154851] = true,
		[157910] = true,
		[158422] = true,
		[154839] = true,
		[159446] = true,
		[163424] = true,
		[160470] = true,
		[163371] = true,
		[163369] = true,
		[157911] = true,
		[158423] = true,
		[154840] = true,
		[163368] = true,
		[155864] = true,
		[160471] = true,
		[163300] = true,
		[163366] = true,
		[157912] = true,
		[158424] = true,
		[163365] = true,
		[159448] = true,
		[163432] = true,
		[160472] = true,
		[160984] = true,
		[163349] = true,
		[157913] = true,
		[158425] = true,
		[154842] = true,
		[159449] = true,
		[155866] = true,
		[160473] = true,
		[160985] = true,
		[163360] = true,
		[157914] = true,
		[158426] = true,
		[154843] = true,
		[159450] = true,
		[163358] = true,
		[160474] = true,
		[163357] = true,
		[155109] = true,
		[157915] = true,
		[162884] = true,
		[154844] = true,
		[159451] = true,
		[155868] = true,
		[160475] = true,
		[160987] = true,
		[162883] = true,
		[157916] = true,
		[162882] = true,
		[154845] = true,
		[159452] = true,
		[155869] = true,
		[160476] = true,
		[162879] = true,
		[163352] = true,
		[157917] = true,
		[163351] = true,
		[163350] = true,
		[163298] = true,
		[159965] = true,
		[160477] = true,
		[155200] = true,
		[155120] = true,
		[157918] = true,
		[159336] = true,
		[154847] = true,
		[155208] = true,
		[163340] = true,
		[163339] = true,
		[160990] = true,
		[163338] = true,
		[157919] = true,
		[158431] = true,
		[158943] = true,
		[159455] = true,
		[163297] = true,
		[162510] = true,
		[162509] = true,
		[162508] = true,
		[157920] = true,
		[158432] = true,
		[158944] = true,
		[159456] = true,
		[159968] = true,
		[155189] = true,
		[152802] = true,
		[158955] = true,
		[157921] = true,
		[158433] = true,
		[158945] = true,
		[159457] = true,
		[159969] = true,
		[163448] = true,
		[152803] = true,
		[163440] = true,
		[157922] = true,
		[158434] = true,
		[158946] = true,
		[159458] = true,
		[163296] = true,
		[162497] = true,
		[152804] = true,
		[155184] = true,
		[157923] = true,
		[162489] = true,
		[158947] = true,
		[159459] = true,
		[155183] = true,
		[163381] = true,
		[152805] = true,
		[163367] = true,
		[157924] = true,
		[163299] = true,
		[158948] = true,
		[159460] = true,
		[159972] = true,
		[163295] = true,
		[152806] = true,
		[162485] = true,
		[157925] = true,
		[155182] = true,
		[154854] = true,
		[159461] = true,
		[159973] = true,
		[154157] = true,
		[152807] = true,
		[155482] = true,
		[157926] = true,
		[163025] = true,
		[158950] = true,
		[159462] = true,
		[163023] = true,
		[163021] = true,
		[152808] = true,
		[163294] = true,
		[157927] = true,
		[162466] = true,
		[162465] = true,
		[159463] = true,
		[159975] = true,
		[162464] = true,
		[152809] = true,
		[154154] = true,
		[157928] = true,
		[158440] = true,
		[154857] = true,
		[155369] = true,
		[159976] = true,
		[160488] = true,
		[152810] = true,
		[162463] = true,
		[157929] = true,
		[158441] = true,
		[154858] = true,
		[162881] = true,
		[159977] = true,
		[160489] = true,
		[152811] = true,
		[162880] = true,
		[157930] = true,
		[158442] = true,
		[154859] = true,
		[163293] = true,
		[159978] = true,
		[160490] = true,
		[162457] = true,
		[162455] = true,
		[157931] = true,
		[158443] = true,
		[154860] = true,
		[155175] = true,
		[155884] = true,
		[160491] = true,
		[154151] = true,
		[159330] = true,
		[157932] = true,
		[158444] = true,
		[158956] = true,
		[155373] = true,
		[159980] = true,
		[162875] = true,
		[155172] = true,
		[163292] = true,
		[157933] = true,
		[158445] = true,
		[158957] = true,
		[155374] = true,
		[159981] = true,
		[162433] = true,
		[162418] = true,
		[154149] = true,
		[157934] = true,
		[158446] = true,
		[158958] = true,
		[155375] = true,
		[155887] = true,
		[162410] = true,
		[159312] = true,
		[159409] = true,
		[157935] = true,
		[158447] = true,
		[154864] = true,
		[162454] = true,
		[159983] = true,
		[163291] = true,
		[161007] = true,
		[161024] = true,
		[157936] = true,
		[162406] = true,
		[154865] = true,
		[155377] = true,
		[155889] = true,
		[162404] = true,
		[152818] = true,
		[154147] = true,
		[157937] = true,
		[162544] = true,
		[162399] = true,
		[159473] = true,
		[155890] = true,
		[162507] = true,
		[152819] = true,
		[162506] = true,
		[157938] = true,
		[163290] = true,
		[159266] = true,
		[159474] = true,
		[155891] = true,
		[162392] = true,
		[162391] = true,
		[162390] = true,
		[157939] = true,
		[162496] = true,
		[162495] = true,
		[159475] = true,
		[155892] = true,
		[162494] = true,
		[163289] = true,
		[155091] = true,
		[157940] = true,
		[162328] = true,
		[158964] = true,
		[159476] = true,
		[159988] = true,
		[162327] = true,
		[162488] = true,
		[154145] = true,
		[157941] = true,
		[162548] = true,
		[158965] = true,
		[159477] = true,
		[159989] = true,
		[158496] = true,
		[162486] = true,
		[163288] = true,
		[157942] = true,
		[155090] = true,
		[158966] = true,
		[159478] = true,
		[159990] = true,
		[162484] = true,
		[159364] = true,
		[162483] = true,
		[157943] = true,
		[154160] = true,
		[158967] = true,
		[159479] = true,
		[159991] = true,
		[155177] = true,
		[158498] = true,
		[163287] = true,
		[157944] = true,
		[162016] = true,
		[158968] = true,
		[159480] = true,
		[159992] = true,
		[155162] = true,
		[162002] = true,
		[154138] = true,
		[157945] = true,
		[159514] = true,
		[158969] = true,
		[159481] = true,
		[159993] = true,
		[155159] = true,
		[152827] = true,
		[158500] = true,
		[157946] = true,
		[163286] = true,
		[158970] = true,
		[159482] = true,
		[159994] = true,
		[162774] = true,
		[152828] = true,
		[155414] = true,
		[157947] = true,
		[155158] = true,
		[158971] = true,
		[155388] = true,
		[159995] = true,
		[158949] = true,
		[161019] = true,
		[155412] = true,
		[157948] = true,
		[161985] = true,
		[158972] = true,
		[155389] = true,
		[159996] = true,
		[162442] = true,
		[152830] = true,
		[163285] = true,
		[157949] = true,
		[162441] = true,
		[158973] = true,
		[159485] = true,
		[159997] = true,
		[162440] = true,
		[152831] = true,
		[162590] = true,
		[157950] = true,
		[155155] = true,
		[158974] = true,
		[159486] = true,
		[159998] = true,
		[155424] = true,
		[152832] = true,
		[161983] = true,
		[157951] = true,
		[162417] = true,
		[158975] = true,
		[159487] = true,
		[159999] = true,
		[163284] = true,
		[152833] = true,
		[159520] = true,
		[157952] = true,
		[162409] = true,
		[162592] = true,
		[159488] = true,
		[160000] = true,
		[161979] = true,
		[152834] = true,
		[161978] = true,
		[157953] = true,
		[155152] = true,
		[162403] = true,
		[159489] = true,
		[160001] = true,
		[163283] = true,
		[152835] = true,
		[162402] = true,
		[157954] = true,
		[161975] = true,
		[161971] = true,
		[159490] = true,
		[160002] = true,
		[162397] = true,
		[161026] = true,
		[155150] = true,
		[157955] = true,
		[158467] = true,
		[158979] = true,
		[159491] = true,
		[160003] = true,
		[162394] = true,
		[152837] = true,
		[162393] = true,
		[157956] = true,
		[158468] = true,
		[158980] = true,
		[159492] = true,
		[160004] = true,
		[163282] = true,
		[161028] = true,
		[155148] = true,
		[157957] = true,
		[158469] = true,
		[158981] = true,
		[159493] = true,
		[160005] = true,
		[155244] = true,
		[161029] = true,
		[159416] = true,
		[157958] = true,
		[158470] = true,
		[158982] = true,
		[159494] = true,
		[160006] = true,
		[162354] = true,
		[161030] = true,
		[159527] = true,
		[157959] = true,
		[158471] = true,
		[158983] = true,
		[155400] = true,
		[160007] = true,
		[160519] = true,
		[161031] = true,
		[162330] = true,
		[157960] = true,
		[158472] = true,
		[158984] = true,
		[155401] = true,
		[160008] = true,
		[160520] = true,
		[161032] = true,
		[162329] = true,
		[157961] = true,
		[158473] = true,
		[158985] = true,
		[155402] = true,
		[160009] = true,
		[160521] = true,
		[161033] = true,
		[163281] = true,
		[157962] = true,
		[158474] = true,
		[158986] = true,
		[155403] = true,
		[160010] = true,
		[160522] = true,
		[161034] = true,
		[155438] = true,
		[157963] = true,
		[158475] = true,
		[159528] = true,
		[155404] = true,
		[160011] = true,
		[155198] = true,
		[161035] = true,
		[162325] = true,
		[157964] = true,
		[158476] = true,
		[159505] = true,
		[155405] = true,
		[160012] = true,
		[162323] = true,
		[161036] = true,
		[159352] = true,
		[157965] = true,
		[158477] = true,
		[163280] = true,
		[159501] = true,
		[160013] = true,
		[162768] = true,
		[161037] = true,
		[155468] = true,
		[157966] = true,
		[158478] = true,
		[159359] = true,
		[155407] = true,
		[160014] = true,
		[155242] = true,
		[161038] = true,
		[154150] = true,
		[157967] = true,
		[158479] = true,
		[158991] = true,
		[155408] = true,
		[160015] = true,
		[158518] = true,
		[161039] = true,
		[155218] = true,
		[157968] = true,
		[158480] = true,
		[158992] = true,
		[159504] = true,
		[160016] = true,
		[159184] = true,
		[161040] = true,
		[162767] = true,
		[157969] = true,
		[158481] = true,
		[158993] = true,
		[155410] = true,
		[160017] = true,
		[155398] = true,
		[161041] = true,
		[155444] = true,
		[157970] = true,
		[158482] = true,
		[158994] = true,
		[159506] = true,
		[160018] = true,
		[154163] = true,
		[161042] = true,
		[159566] = true,
		[157971] = true,
		[158483] = true,
		[155397] = true,
		[159507] = true,
		[160019] = true,
		[158520] = true,
		[161043] = true,
		[153365] = true,
		[157972] = true,
		[158484] = true,
		[154389] = true,
		[155413] = true,
		[160020] = true,
		[162766] = true,
		[161044] = true,
		[153366] = true,
		[157973] = true,
		[158485] = true,
		[159358] = true,
		[159509] = true,
		[160021] = true,
		[159172] = true,
		[161045] = true,
		[153367] = true,
		[157974] = true,
		[158486] = true,
		[158521] = true,
		[155415] = true,
		[160022] = true,
		[159537] = true,
		[161046] = true,
		[153368] = true,
		[157975] = true,
		[158487] = true,
		[161998] = true,
		[155416] = true,
		[160023] = true,
		[161997] = true,
		[161047] = true,
		[153369] = true,
		[157976] = true,
		[158488] = true,
		[159000] = true,
		[155417] = true,
		[160024] = true,
		[162614] = true,
		[161048] = true,
		[153370] = true,
		[157977] = true,
		[158489] = true,
		[159001] = true,
		[155418] = true,
		[162765] = true,
		[161996] = true,
		[161049] = true,
		[153371] = true,
		[157978] = true,
		[158490] = true,
		[159002] = true,
		[155419] = true,
		[161995] = true,
		[161994] = true,
		[159340] = true,
		[153372] = true,
		[157979] = true,
		[158491] = true,
		[159003] = true,
		[155420] = true,
		[161993] = true,
		[161990] = true,
		[163276] = true,
		[153373] = true,
		[157980] = true,
		[158492] = true,
		[162764] = true,
		[159516] = true,
		[160028] = true,
		[161987] = true,
		[162618] = true,
		[153374] = true,
		[157981] = true,
		[158493] = true,
		[161986] = true,
		[155422] = true,
		[160029] = true,
		[155392] = true,
		[159982] = true,
		[153375] = true,
		[157982] = true,
		[158494] = true,
		[158525] = true,
		[155423] = true,
		[160030] = true,
		[163275] = true,
		[162763] = true,
		[153376] = true,
		[157983] = true,
		[158495] = true,
		[155454] = true,
		[159519] = true,
		[160031] = true,
		[154862] = true,
		[161982] = true,
		[153377] = true,
		[157984] = true,
		[162591] = true,
		[155456] = true,
		[155425] = true,
		[160032] = true,
		[155391] = true,
		[161980] = true,
		[153378] = true,
		[157985] = true,
		[158497] = true,
		[163274] = true,
		[159521] = true,
		[160033] = true,
		[162762] = true,
		[155881] = true,
		[153379] = true,
		[157986] = true,
		[162593] = true,
		[159010] = true,
		[155427] = true,
		[160034] = true,
		[155390] = true,
		[158527] = true,
		[153380] = true,
		[157987] = true,
		[158499] = true,
		[159011] = true,
		[159523] = true,
		[158257] = true,
		[159041] = true,
		[161972] = true,
		[153381] = true,
		[157988] = true,
		[162595] = true,
		[159012] = true,
		[159524] = true,
		[163273] = true,
		[162761] = true,
		[155489] = true,
		[153382] = true,
		[157989] = true,
		[158501] = true,
		[159013] = true,
		[155430] = true,
		[155072] = true,
		[161969] = true,
		[152871] = true,
		[153383] = true,
		[157990] = true,
		[162597] = true,
		[159014] = true,
		[155431] = true,
		[161968] = true,
		[155101] = true,
		[152872] = true,
		[153384] = true,
		[157991] = true,
		[158503] = true,
		[159015] = true,
		[155432] = true,
		[161966] = true,
		[163272] = true,
		[152873] = true,
		[153385] = true,
		[157992] = true,
		[158504] = true,
		[159016] = true,
		[155433] = true,
		[162760] = true,
		[155128] = true,
		[152874] = true,
		[153386] = true,
		[157993] = true,
		[158505] = true,
		[159017] = true,
		[155434] = true,
		[155099] = true,
		[159353] = true,
		[159366] = true,
		[153387] = true,
		[157994] = true,
		[158506] = true,
		[159018] = true,
		[159530] = true,
		[155462] = true,
		[159410] = true,
		[163271] = true,
		[153388] = true,
		[157995] = true,
		[158507] = true,
		[159019] = true,
		[159531] = true,
		[163653] = true,
		[155127] = true,
		[154943] = true,
		[153389] = true,
		[157996] = true,
		[158508] = true,
		[159020] = true,
		[159532] = true,
		[154952] = true,
		[159431] = true,
		[155382] = true,
		[153390] = true,
		[157997] = true,
		[158509] = true,
		[155479] = true,
		[159533] = true,
		[163270] = true,
		[163655] = true,
		[159979] = true,
		[153391] = true,
		[157998] = true,
		[158510] = true,
		[154954] = true,
		[163656] = true,
		[155190] = true,
		[159986] = true,
		[159040] = true,
		[153392] = true,
		[157999] = true,
		[158511] = true,
		[163269] = true,
		[155440] = true,
		[159046] = true,
		[155381] = true,
		[161071] = true,
		[153393] = true,
		[158000] = true,
		[158512] = true,
		[163658] = true,
		[159536] = true,
		[155124] = true,
		[159052] = true,
		[161072] = true,
		[153394] = true,
		[158001] = true,
		[158513] = true,
		[159025] = true,
		[155442] = true,
		[163659] = true,
		[154148] = true,
		[161073] = true,
		[153395] = true,
		[158002] = true,
		[158514] = true,
		[159026] = true,
		[155443] = true,
		[163268] = true,
		[154156] = true,
		[161074] = true,
		[153396] = true,
		[158003] = true,
		[158515] = true,
		[159027] = true,
		[159539] = true,
		[155421] = true,
		[158542] = true,
		[161075] = true,
		[153397] = true,
		[158004] = true,
		[158516] = true,
		[159028] = true,
		[159540] = true,
		[155164] = true,
		[154139] = true,
		[161076] = true,
		[153398] = true,
		[158005] = true,
		[162612] = true,
		[159029] = true,
		[158543] = true,
		[155473] = true,
		[163267] = true,
		[161077] = true,
		[155300] = true,
		[158006] = true,
		[162613] = true,
		[159569] = true,
		[163664] = true,
		[155888] = true,
		[159529] = true,
		[159163] = true,
		[153400] = true,
		[158007] = true,
		[158519] = true,
		[154936] = true,
		[155448] = true,
		[159517] = true,
		[163266] = true,
		[155178] = true,
		[153401] = true,
		[158008] = true,
		[162615] = true,
		[154937] = true,
		[159544] = true,
		[155399] = true,
		[159060] = true,
		[163667] = true,
		[153402] = true,
		[158009] = true,
		[162616] = true,
		[154938] = true,
		[159545] = true,
		[159575] = true,
		[155445] = true,
		[155481] = true,
		[153403] = true,
		[158010] = true,
		[158522] = true,
		[159034] = true,
		[159546] = true,
		[163265] = true,
		[155119] = true,
		[155393] = true,
		[153404] = true,
		[158011] = true,
		[158523] = true,
		[154940] = true,
		[159547] = true,
		[161018] = true,
		[155886] = true,
		[158238] = true,
		[153405] = true,
		[158012] = true,
		[158524] = true,
		[154941] = true,
		[159548] = true,
		[159066] = true,
		[155385] = true,
		[163264] = true,
		[153406] = true,
		[158013] = true,
		[162620] = true,
		[159037] = true,
		[159549] = true,
		[161025] = true,
		[159987] = true,
		[154461] = true,
		[153407] = true,
		[158014] = true,
		[154431] = true,
		[159038] = true,
		[155455] = true,
		[155485] = true,
		[155122] = true,
		[154140] = true,
		[153408] = true,
		[158015] = true,
		[162622] = true,
		[159039] = true,
		[159551] = true,
		[158557] = true,
		[163263] = true,
		[159069] = true,
		[153409] = true,
		[158016] = true,
		[158528] = true,
		[154945] = true,
		[155457] = true,
		[158558] = true,
		[159408] = true,
		[159071] = true,
		[153410] = true,
		[158017] = true,
		[158529] = true,
		[154946] = true,
		[155229] = true,
		[163679] = true,
		[159679] = true,
		[163262] = true,
		[153411] = true,
		[158018] = true,
		[158530] = true,
		[154947] = true,
		[155459] = true,
		[159283] = true,
		[155199] = true,
		[155395] = true,
		[153412] = true,
		[158019] = true,
		[158531] = true,
		[154948] = true,
		[155460] = true,
		[159585] = true,
		[159568] = true,
		[161091] = true,
		[153413] = true,
		[158020] = true,
		[158532] = true,
		[154949] = true,
		[159556] = true,
		[159074] = true,
		[154942] = true,
		[161092] = true,
		[161604] = true,
		[158021] = true,
		[158533] = true,
		[159045] = true,
		[159557] = true,
		[163261] = true,
		[155168] = true,
		[161093] = true,
		[153415] = true,
		[158022] = true,
		[158534] = true,
		[154951] = true,
		[159558] = true,
		[155093] = true,
		[159399] = true,
		[161094] = true,
		[161606] = true,
		[158023] = true,
		[158535] = true,
		[159047] = true,
		[163654] = true,
		[159436] = true,
		[155117] = true,
		[161095] = true,
		[153417] = true,
		[158024] = true,
		[158536] = true,
		[154953] = true,
		[155465] = true,
		[154982] = true,
		[155239] = true,
		[163260] = true,
		[161608] = true,
		[158025] = true,
		[158537] = true,
		[159049] = true,
		[155466] = true,
		[154983] = true,
		[159525] = true,
		[161097] = true,
		[161609] = true,
		[158026] = true,
		[158538] = true,
		[154955] = true,
		[163657] = true,
		[159079] = true,
		[154152] = true,
		[161098] = true,
		[161610] = true,
		[158027] = true,
		[158539] = true,
		[159051] = true,
		[159563] = true,
		[159311] = true,
		[155112] = true,
		[161099] = true,
		[161611] = true,
		[158028] = true,
		[158540] = true,
		[154957] = true,
		[159564] = true,
		[154980] = true,
		[163259] = true,
		[161100] = true,
		[161612] = true,
		[158029] = true,
		[158541] = true,
		[154958] = true,
		[163660] = true,
		[159081] = true,
		[155096] = true,
		[161101] = true,
		[161613] = true,
		[158030] = true,
		[154447] = true,
		[154959] = true,
		[155471] = true,
		[160078] = true,
		[158569] = true,
		[161102] = true,
		[161614] = true,
		[158031] = true,
		[154448] = true,
		[154960] = true,
		[158570] = true,
		[160079] = true,
		[155212] = true,
		[161103] = true,
		[161615] = true,
		[158032] = true,
		[154449] = true,
		[154961] = true,
		[163663] = true,
		[160080] = true,
		[154863] = true,
		[161104] = true,
		[161616] = true,
		[158033] = true,
		[158545] = true,
		[159057] = true,
		[155474] = true,
		[160081] = true,
		[155469] = true,
		[161105] = true,
		[161617] = true,
		[158034] = true,
		[158546] = true,
		[159058] = true,
		[163665] = true,
		[160082] = true,
		[163258] = true,
		[161106] = true,
		[161618] = true,
		[158035] = true,
		[158547] = true,
		[154964] = true,
		[159571] = true,
		[160083] = true,
		[155205] = true,
		[161107] = true,
		[161619] = true,
		[158036] = true,
		[154453] = true,
		[154965] = true,
		[159572] = true,
		[160084] = true,
		[158573] = true,
		[161108] = true,
		[161620] = true,
		[158037] = true,
		[158549] = true,
		[154966] = true,
		[159573] = true,
		[160085] = true,
		[158571] = true,
		[161109] = true,
		[161621] = true,
		[158038] = true,
		[158550] = true,
		[154967] = true,
		[159574] = true,
		[160086] = true,
		[155203] = true,
		[161110] = true,
		[161622] = true,
		[158039] = true,
		[158551] = true,
		[154968] = true,
		[163670] = true,
		[160087] = true,
		[154153] = true,
		[161111] = true,
		[161623] = true,
		[158040] = true,
		[158552] = true,
		[154969] = true,
		[159576] = true,
		[160088] = true,
		[155429] = true,
		[161112] = true,
		[161624] = true,
		[158041] = true,
		[158553] = true,
		[161021] = true,
		[159577] = true,
		[160089] = true,
		[163257] = true,
		[161113] = true,
		[161625] = true,
		[158042] = true,
		[162745] = true,
		[154971] = true,
		[159578] = true,
		[160090] = true,
		[158575] = true,
		[159511] = true,
		[161626] = true,
		[158043] = true,
		[154460] = true,
		[159067] = true,
		[155484] = true,
		[160091] = true,
		[161020] = true,
		[161115] = true,
		[161627] = true,
		[158044] = true,
		[158556] = true,
		[159068] = true,
		[163675] = true,
		[154939] = true,
		[155107] = true,
		[155156] = true,
		[161628] = true,
		[158045] = true,
		[162652] = true,
		[154974] = true,
		[163676] = true,
		[160093] = true,
		[163256] = true,
		[161117] = true,
		[161629] = true,
		[158046] = true,
		[162653] = true,
		[159070] = true,
		[155487] = true,
		[160094] = true,
		[155104] = true,
		[161118] = true,
		[161630] = true,
		[158047] = true,
		[154464] = true,
		[154976] = true,
		[163678] = true,
		[160095] = true,
		[159264] = true,
		[161119] = true,
		[161631] = true,
		[158048] = true,
		[162655] = true,
		[154977] = true,
		[159584] = true,
		[160096] = true,
		[159169] = true,
		[155348] = true,
		[159497] = true,
		[158049] = true,
		[154466] = true,
		[154978] = true,
		[163680] = true,
		[160097] = true,
		[155105] = true,
		[154155] = true,
		[161633] = true,
		[158050] = true,
		[154467] = true,
		[154979] = true,
		[163255] = true,
		[160098] = true,
		[159292] = true,
		[159414] = true,
		[161634] = true,
		[158051] = true,
		[158563] = true,
		[159075] = true,
		[159587] = true,
		[160099] = true,
		[159543] = true,
		[155240] = true,
		[161635] = true,
		[158052] = true,
		[158564] = true,
		[154981] = true,
		[155362] = true,
		[160100] = true,
		[160612] = true,
		[155092] = true,
		[161636] = true,
		[158053] = true,
		[158565] = true,
		[159077] = true,
		[159589] = true,
		[161607] = true,
		[160613] = true,
		[161125] = true,
		[161637] = true,
		[158054] = true,
		[158566] = true,
		[159078] = true,
		[159590] = true,
		[163254] = true,
		[160614] = true,
		[155192] = true,
		[161638] = true,
		[158055] = true,
		[158567] = true,
		[154984] = true,
		[154458] = true,
		[155059] = true,
		[160615] = true,
		[159418] = true,
		[161639] = true,
		[158056] = true,
		[158568] = true,
		[163703] = true,
		[159318] = true,
		[154975] = true,
		[160616] = true,
		[163253] = true,
		[161640] = true,
		[158057] = true,
		[154474] = true,
		[154986] = true,
		[159593] = true,
		[155058] = true,
		[160617] = true,
		[154956] = true,
		[161641] = true,
		[158058] = true,
		[154475] = true,
		[154987] = true,
		[159594] = true,
		[159099] = true,
		[160618] = true,
		[159560] = true,
		[161642] = true,
		[158059] = true,
		[154476] = true,
		[159083] = true,
		[159595] = true,
		[155187] = true,
		[160619] = true,
		[155519] = true,
		[161643] = true,
		[158060] = true,
		[158572] = true,
		[159084] = true,
		[159596] = true,
		[159615] = true,
		[160620] = true,
		[163252] = true,
		[161644] = true,
		[158061] = true,
		[154478] = true,
		[159085] = true,
		[159597] = true,
		[155521] = true,
		[160621] = true,
		[154416] = true,
		[161645] = true,
		[158062] = true,
		[158574] = true,
		[159086] = true,
		[159598] = true,
		[160110] = true,
		[160622] = true,
		[159422] = true,
		[161646] = true,
		[159166] = true,
		[162670] = true,
		[159087] = true,
		[159599] = true,
		[159341] = true,
		[160623] = true,
		[159299] = true,
		[161647] = true,
		[159668] = true,
		[159411] = true,
		[159088] = true,
		[159600] = true,
		[158595] = true,
		[160624] = true,
		[155524] = true,
		[161648] = true,
		[154146] = true,
		[158577] = true,
		[159089] = true,
		[159601] = true,
		[159535] = true,
		[160625] = true,
		[154141] = true,
		[161649] = true,
		[155097] = true,
		[158578] = true,
		[159090] = true,
		[159602] = true,
		[159667] = true,
		[160626] = true,
		[163250] = true,
		[161650] = true,
		[159363] = true,
		[158579] = true,
		[159091] = true,
		[163721] = true,
		[159036] = true,
		[160627] = true,
		[161139] = true,
		[161651] = true,
		[159035] = true,
		[158580] = true,
		[159092] = true,
		[159604] = true,
		[158256] = true,
		[160628] = true,
		[161140] = true,
		[161652] = true,
		[159116] = true,
		[158581] = true,
		[159093] = true,
		[155510] = true,
		[155571] = true,
		[160629] = true,
		[161141] = true,
		[161653] = true,
		[163249] = true,
		[158582] = true,
		[159094] = true,
		[159606] = true,
		[163723] = true,
		[160630] = true,
		[161142] = true,
		[161654] = true,
		[159115] = true,
		[158583] = true,
		[159095] = true,
		[159607] = true,
		[160119] = true,
		[160631] = true,
		[161143] = true,
		[161655] = true,
		[159117] = true,
		[158584] = true,
		[159096] = true,
		[159608] = true,
		[160120] = true,
		[160632] = true,
		[155173] = true,
		[161656] = true,
		[155023] = true,
		[158585] = true,
		[159097] = true,
		[159609] = true,
		[160121] = true,
		[160633] = true,
		[162702] = true,
		[161657] = true,
		[155570] = true,
		[158586] = true,
		[159098] = true,
		[159610] = true,
		[160122] = true,
		[160634] = true,
		[163248] = true,
		[161658] = true,
		[159119] = true,
		[158587] = true,
		[150909] = true,
		[159611] = true,
		[160123] = true,
		[160635] = true,
		[155025] = true,
		[161659] = true,
		[155232] = true,
		[158588] = true,
		[159100] = true,
		[159612] = true,
		[160124] = true,
		[160636] = true,
		[161022] = true,
		[161660] = true,
		[163729] = true,
		[158589] = true,
		[159101] = true,
		[155214] = true,
		[160125] = true,
		[160637] = true,
		[159664] = true,
		[161661] = true,
		[159152] = true,
		[158590] = true,
		[159102] = true,
		[159614] = true,
		[160126] = true,
		[160638] = true,
		[162735] = true,
		[161662] = true,
		[158079] = true,
		[158591] = true,
		[159103] = true,
		[155520] = true,
		[160127] = true,
		[160639] = true,
		[155094] = true,
		[161663] = true,
		[162706] = true,
		[158592] = true,
		[159104] = true,
		[159616] = true,
		[160128] = true,
		[160640] = true,
		[155026] = true,
		[159274] = true,
		[162707] = true,
		[158593] = true,
		[159105] = true,
		[155522] = true,
		[160129] = true,
		[160641] = true,
		[155568] = true,
		[163246] = true,
		[162734] = true,
		[158594] = true,
		[159106] = true,
		[159618] = true,
		[160130] = true,
		[160642] = true,
		[159124] = true,
		[163731] = true,
		[159635] = true,
		[154500] = true,
		[159107] = true,
		[159619] = true,
		[160131] = true,
		[160643] = true,
		[155170] = true,
		[155031] = true,
		[158084] = true,
		[159662] = true,
		[159108] = true,
		[159620] = true,
		[160132] = true,
		[160644] = true,
		[163245] = true,
		[161668] = true,
		[158085] = true,
		[158597] = true,
		[159109] = true,
		[159638] = true,
		[160133] = true,
		[160645] = true,
		[159304] = true,
		[161669] = true,
		[158086] = true,
		[158598] = true,
		[159110] = true,
		[159622] = true,
		[160134] = true,
		[160646] = true,
		[161158] = true,
		[158613] = true,
		[158087] = true,
		[158599] = true,
		[159111] = true,
		[159623] = true,
		[160135] = true,
		[160647] = true,
		[161159] = true,
		[161671] = true,
		[158088] = true,
		[158600] = true,
		[159112] = true,
		[159624] = true,
		[160136] = true,
		[160648] = true,
		[161160] = true,
		[161672] = true,
		[158089] = true,
		[158601] = true,
		[155030] = true,
		[159625] = true,
		[160137] = true,
		[160649] = true,
		[161161] = true,
		[159985] = true,
		[158090] = true,
		[158602] = true,
		[159114] = true,
		[159626] = true,
		[160138] = true,
		[160650] = true,
		[159508] = true,
		[161674] = true,
		[158091] = true,
		[158603] = true,
		[155020] = true,
		[159627] = true,
		[160139] = true,
		[160651] = true,
		[155180] = true,
		[161675] = true,
		[158092] = true,
		[158604] = true,
		[155021] = true,
		[159628] = true,
		[160140] = true,
		[160652] = true,
		[155054] = true,
		[161676] = true,
		[158093] = true,
		[158605] = true,
		[155022] = true,
		[163724] = true,
		[160141] = true,
		[160653] = true,
		[155035] = true,
		[161677] = true,
		[158094] = true,
		[158606] = true,
		[159118] = true,
		[159630] = true,
		[160142] = true,
		[160654] = true,
		[161166] = true,
		[161678] = true,
		[158095] = true,
		[158607] = true,
		[155024] = true,
		[159631] = true,
		[160143] = true,
		[160655] = true,
		[161167] = true,
		[161679] = true,
		[158096] = true,
		[158608] = true,
		[159120] = true,
		[159632] = true,
		[160144] = true,
		[160656] = true,
		[161168] = true,
		[161680] = true,
		[158097] = true,
		[158609] = true,
		[159121] = true,
		[159633] = true,
		[160145] = true,
		[159321] = true,
		[161169] = true,
		[161681] = true,
		[158098] = true,
		[158610] = true,
		[159122] = true,
		[159634] = true,
		[160146] = true,
		[159131] = true,
		[161170] = true,
		[155103] = true,
		[158099] = true,
		[158611] = true,
		[155028] = true,
		[163730] = true,
		[160147] = true,
		[159132] = true,
		[161171] = true,
		[161683] = true,
		[158100] = true,
		[158612] = true,
		[155029] = true,
		[159636] = true,
		[160148] = true,
		[155039] = true,
		[161172] = true,
		[161684] = true,
		[158101] = true,
		[162708] = true,
		[159125] = true,
		[159637] = true,
		[160149] = true,
		[159660] = true,
		[161173] = true,
		[161685] = true,
		[158102] = true,
		[158614] = true,
		[159126] = true,
		[155543] = true,
		[160150] = true,
		[155053] = true,
		[161174] = true,
		[161686] = true,
		[158103] = true,
		[158615] = true,
		[159127] = true,
		[159639] = true,
		[160151] = true,
		[159646] = true,
		[161175] = true,
		[161687] = true,
		[158104] = true,
		[158616] = true,
		[155033] = true,
		[155545] = true,
		[160152] = true,
		[155040] = true,
		[161176] = true,
		[155041] = true,
		[158105] = true,
		[158617] = true,
		[155034] = true,
		[159641] = true,
		[160153] = true,
		[159129] = true,
		[161177] = true,
		[161689] = true,
		[158106] = true,
		[158618] = true,
		[159130] = true,
		[159642] = true,
		[160154] = true,
		[161696] = true,
		[161178] = true,
		[161690] = true,
		[158107] = true,
		[158619] = true,
		[155036] = true,
		[159643] = true,
		[160155] = true,
		[162720] = true,
		[161179] = true,
		[161691] = true,
		[158108] = true,
		[158620] = true,
		[155037] = true,
		[159644] = true,
		[160156] = true,
		[159659] = true,
		[161180] = true,
		[161692] = true,
		[158109] = true,
		[158621] = true,
		[155038] = true,
		[159645] = true,
		[160157] = true,
		[155052] = true,
		[161181] = true,
		[161693] = true,
		[158110] = true,
		[158622] = true,
		[159134] = true,
		[155551] = true,
		[160158] = true,
		[155042] = true,
		[161182] = true,
		[161694] = true,
		[158111] = true,
		[158623] = true,
		[159135] = true,
		[159647] = true,
		[160159] = true,
		[155556] = true,
		[161183] = true,
		[161695] = true,
		[158112] = true,
		[158624] = true,
		[159136] = true,
		[159648] = true,
		[160160] = true,
		[159269] = true,
		[161184] = true,
		[153506] = true,
		[159655] = true,
		[158625] = true,
		[159137] = true,
		[159649] = true,
		[160161] = true,
		[160673] = true,
		[161185] = true,
		[161697] = true,
		[158114] = true,
		[158626] = true,
		[155043] = true,
		[159650] = true,
		[160162] = true,
		[160674] = true,
		[161186] = true,
		[161698] = true,
		[158115] = true,
		[158627] = true,
		[155044] = true,
		[159651] = true,
		[160163] = true,
		[160675] = true,
		[161187] = true,
		[161699] = true,
		[158116] = true,
		[158628] = true,
		[155045] = true,
		[159652] = true,
		[160164] = true,
		[160676] = true,
		[161188] = true,
		[161700] = true,
		[158117] = true,
		[158629] = true,
		[155046] = true,
		[159653] = true,
		[160165] = true,
		[160677] = true,
		[161189] = true,
		[161701] = true,
		[158118] = true,
		[158630] = true,
		[155047] = true,
		[159654] = true,
		[160166] = true,
		[160678] = true,
		[161190] = true,
		[161702] = true,
		[162728] = true,
		[158631] = true,
		[155048] = true,
		[155560] = true,
		[160167] = true,
		[160679] = true,
		[161191] = true,
		[161703] = true,
		[158120] = true,
		[158632] = true,
		[155049] = true,
		[159656] = true,
		[160168] = true,
		[160680] = true,
		[161192] = true,
		[161704] = true,
		[158121] = true,
		[158633] = true,
		[155050] = true,
		[159657] = true,
		[160169] = true,
		[160681] = true,
		[161193] = true,
		[162729] = true,
		[158122] = true,
		[158634] = true,
		[155051] = true,
		[159658] = true,
		[160170] = true,
		[160682] = true,
		[161194] = true,
		[161706] = true,
		[158123] = true,
		[162730] = true,
		[159147] = true,
		[155564] = true,
		[160171] = true,
		[160683] = true,
		[161195] = true,
		[161707] = true,
		[158124] = true,
		[162731] = true,
		[159148] = true,
		[155565] = true,
		[160172] = true,
		[160684] = true,
		[159133] = true,
		[161708] = true,
		[158125] = true,
		[162732] = true,
		[159149] = true,
		[159661] = true,
		[160173] = true,
		[160685] = true,
		[159128] = true,
		[155032] = true,
		[158126] = true,
		[162733] = true,
		[155055] = true,
		[155567] = true,
		[160174] = true,
		[160686] = true,
		[163732] = true,
		[161710] = true,
		[158127] = true,
		[158639] = true,
		[159151] = true,
		[159663] = true,
		[160175] = true,
		[160687] = true,
		[159123] = true,
		[161711] = true,
		[158128] = true,
		[158640] = true,
		[155057] = true,
		[155569] = true,
		[160176] = true,
		[160688] = true,
		[155027] = true,
		[161712] = true,
		[158129] = true,
		[158641] = true,
		[159153] = true,
		[159665] = true,
		[160177] = true,
		[160689] = true,
		[162701] = true,
		[161713] = true,
		[158130] = true,
		[158642] = true,
		[159154] = true,
		[159666] = true,
		[160178] = true,
		[160690] = true,
		[163722] = true,
		[161714] = true,
		[158131] = true,
		[158643] = true,
		[159155] = true,
		[155572] = true,
		[160179] = true,
		[160691] = true,
		[159150] = true,
		[161715] = true,
		[158132] = true,
		[158644] = true,
		[163251] = true,
		[155573] = true,
		[160180] = true,
		[160692] = true,
		[159617] = true,
		[161716] = true,
		[158133] = true,
		[158645] = true,
		[155062] = true,
		[159669] = true,
		[160181] = true,
		[160693] = true,
		[161027] = true,
		[161717] = true,
		[158134] = true,
		[158646] = true,
		[159158] = true,
		[159073] = true,
		[160182] = true,
		[160694] = true,
		[155237] = true,
		[161718] = true,
		[158135] = true,
		[158647] = true,
		[155064] = true,
		[159605] = true,
		[160183] = true,
		[160695] = true,
		[154183] = true,
		[161719] = true,
		[158136] = true,
		[158648] = true,
		[155065] = true,
		[155409] = true,
		[160184] = true,
		[160696] = true,
		[155131] = true,
		[161720] = true,
		[155490] = true,
		[158649] = true,
		[155066] = true,
		[155351] = true,
		[160185] = true,
		[155143] = true,
		[162669] = true,
		[161721] = true,
		[155146] = true,
		[158650] = true,
		[159162] = true,
		[162668] = true,
		[160186] = true,
		[160698] = true,
		[155185] = true,
		[161722] = true,
		[154853] = true,
		[162746] = true,
		[155068] = true,
		[159082] = true,
		[164282] = true,
		[160699] = true,
		[154972] = true,
		[161723] = true,
		[155063] = true,
		[155365] = true,
		[159164] = true,
		[155581] = true,
		[164283] = true,
		[161599] = true,
		[161602] = true,
		[161724] = true,
		[161603] = true,
		[158653] = true,
		[155070] = true,
		[155582] = true,
		[160189] = true,
		[161605] = true,
		[161601] = true,
		[161725] = true,
		[159432] = true,
		[155477] = true,
		[155071] = true,
		[155583] = true,
		[160190] = true,
		[158562] = true,
		[159306] = true,
		[161726] = true,
		[159360] = true,
		[158655] = true,
		[159167] = true,
		[155584] = true,
		[160191] = true,
		[159072] = true,
		[155116] = true,
		[161727] = true,
		[159161] = true,
		[158656] = true,
		[159168] = true,
		[159349] = true,
		[160192] = true,
		[155885] = true,
		[154973] = true,
		[161728] = true,
		[158555] = true,
		[158657] = true,
		[155074] = true,
		[163673] = true,
		[160193] = true,
		[163672] = true,
		[161217] = true,
		[161729] = true,
		[163671] = true,
		[158658] = true,
		[155075] = true,
		[163669] = true,
		[160194] = true,
		[163668] = true,
		[161218] = true,
		[161730] = true,
		[158548] = true,
		[158659] = true,
		[155076] = true,
		[163666] = true,
		[160195] = true,
		[154963] = true,
		[161219] = true,
		[161731] = true,
		[154962] = true,
		[158660] = true,
		[155077] = true,
		[158544] = true,
		[160196] = true,
		[159288] = true,
		[163661] = true,
		[161732] = true,
		[155378] = true,
		[154315] = true,
		[159173] = true,
		[155098] = true,
		[160197] = true,
		[155123] = true,
		[161221] = true,
		[161733] = true,
		[158150] = true,
		[158662] = true,
		[159174] = true,
		[159050] = true,
		[160198] = true,
		[155396] = true,
		[161222] = true,
		[161734] = true,
		[158151] = true,
		[158663] = true,
		[155080] = true,
		[159048] = true,
		[160199] = true,
		[159984] = true,
		[161223] = true,
		[161735] = true,
		[158152] = true,
		[158664] = true,
		[155081] = true,
		[155383] = true,
		[160200] = true,
		[154950] = true,
		[155350] = true,
		[161736] = true,
		[158153] = true,
		[158665] = true,
		[155082] = true,
		[155384] = true,
		[160201] = true,
		[155386] = true,
		[154848] = true,
		[161737] = true,
		[158154] = true,
		[158666] = true,
		[155083] = true,
		[155387] = true,
		[160202] = true,
		[160714] = true,
		[155111] = true,
		[161738] = true,
		[158155] = true,
		[158667] = true,
		[159179] = true,
		[155073] = true,
		[160203] = true,
		[160715] = true,
		[154944] = true,
		[161739] = true,
		[162621] = true,
		[158668] = true,
		[155085] = true,
		[155136] = true,
		[160204] = true,
		[160716] = true,
		[162619] = true,
		[161740] = true,
		[159171] = true,
		[158669] = true,
		[155086] = true,
		[155451] = true,
		[164300] = true,
		[160717] = true,
		[155394] = true,
		[155450] = true,
		[159305] = true,
		[158670] = true,
		[163277] = true,
		[155139] = true,
		[164301] = true,
		[160718] = true,
		[159346] = true,
		[161742] = true,
		[158159] = true,
		[158671] = true,
		[163278] = true,
		[159362] = true,
		[160207] = true,
		[160719] = true,
		[159430] = true,
		[161743] = true,
		[158160] = true,
		[158672] = true,
		[155089] = true,
		[159496] = true,
		[164303] = true,
		[160720] = true,
		[155441] = true,
		[161744] = true,
		[158161] = true,
		[158673] = true,
		[159185] = true,
		[154411] = true,
		[164304] = true,
		[160721] = true,
		[154376] = true,
		[161745] = true,
		[158162] = true,
		[158674] = true,
		[159186] = true,
		[159522] = true,
		[164305] = true,
		[160722] = true,
		[155236] = true,
		[161746] = true,
		[158163] = true,
		[158675] = true,
		[159187] = true,
		[161880] = true,
		[164306] = true,
		[160723] = true,
		[161970] = true,
		[161747] = true,
		[158164] = true,
		[161977] = true,
		[159188] = true,
		[162594] = true,
		[160212] = true,
		[160724] = true,
		[161236] = true,
		[161748] = true,
		[158526] = true,
		[162772] = true,
		[159189] = true,
		[161981] = true,
		[160213] = true,
		[160725] = true,
		[161237] = true,
		[161749] = true,
		[159518] = true,
		[155411] = true,
		[155095] = true,
		[161984] = true,
		[160214] = true,
		[160726] = true,
		[161238] = true,
		[161750] = true,
		[162262] = true,
		[158679] = true,
		[159191] = true,
		[159515] = true,
		[160215] = true,
		[160727] = true,
		[161239] = true,
		[161751] = true,
		[162263] = true,
		[158680] = true,
		[159192] = true,
		[162017] = true,
		[160216] = true,
		[160728] = true,
		[155225] = true,
		[161752] = true,
		[155406] = true,
		[158681] = true,
		[159193] = true,
		[154142] = true,
		[164312] = true,
		[160729] = true,
		[162326] = true,
		[161753] = true,
		[162265] = true,
		[158682] = true,
		[159194] = true,
		[155167] = true,
		[164313] = true,
		[154144] = true,
		[161242] = true,
		[161754] = true,
		[162266] = true,
		[158683] = true,
		[155100] = true,
		[162396] = true,
		[164314] = true,
		[160731] = true,
		[161243] = true,
		[161755] = true,
		[162267] = true,
		[158684] = true,
		[159196] = true,
		[162407] = true,
		[164315] = true,
		[160732] = true,
		[161244] = true,
		[161756] = true,
		[162268] = true,
		[158685] = true,
		[155102] = true,
		[162436] = true,
		[164316] = true,
		[160733] = true,
		[161245] = true,
		[161757] = true,
		[162269] = true,
		[158686] = true,
		[159198] = true,
		[162458] = true,
		[164317] = true,
		[160734] = true,
		[161246] = true,
		[161758] = true,
		[162270] = true,
		[158687] = true,
		[159199] = true,
		[162468] = true,
		[164318] = true,
		[162470] = true,
		[162482] = true,
		[161759] = true,
		[162271] = true,
		[158688] = true,
		[159200] = true,
		[154159] = true,
		[164319] = true,
		[162487] = true,
		[161248] = true,
		[161760] = true,
		[162272] = true,
		[158689] = true,
		[155106] = true,
		[162503] = true,
		[164320] = true,
		[162505] = true,
		[161249] = true,
		[161761] = true,
		[162273] = true,
		[158690] = true,
		[159202] = true,
		[162541] = true,
		[162542] = true,
		[155194] = true,
		[161250] = true,
		[161762] = true,
		[162274] = true,
		[158691] = true,
		[155108] = true,
		[162876] = true,
		[162877] = true,
		[162878] = true,
		[161251] = true,
		[161763] = true,
		[158180] = true,
		[158692] = true,
		[159204] = true,
		[162887] = true,
		[164323] = true,
		[154855] = true,
		[161252] = true,
		[161764] = true,
		[163337] = true,
		[155219] = true,
		[159205] = true,
		[163393] = true,
		[164324] = true,
		[163415] = true,
		[161253] = true,
		[161765] = true,
		[162277] = true,
		[158694] = true,
		[159206] = true,
		[163456] = true,
		[164325] = true,
		[163948] = true,
		[161254] = true,
		[161766] = true,
		[162278] = true,
		[158695] = true,
		[159207] = true,
		[163343] = true,
		[164326] = true,
		[163347] = true,
		[159435] = true,
		[161767] = true,
		[162279] = true,
		[158696] = true,
		[155113] = true,
		[163354] = true,
		[164327] = true,
		[163356] = true,
		[159429] = true,
		[161768] = true,
		[162280] = true,
		[158697] = true,
		[155114] = true,
		[159424] = true,
		[164328] = true,
		[159421] = true,
		[159420] = true,
		[161769] = true,
		[162281] = true,
		[163378] = true,
		[155115] = true,
		[163379] = true,
		[164329] = true,
		[159413] = true,
		[159412] = true,
		[161770] = true,
		[162282] = true,
		[158699] = true,
		[159211] = true,
		[163392] = true,
		[164330] = true,
		[159404] = true,
		[159403] = true,
		[161771] = true,
		[162283] = true,
		[158700] = true,
		[159212] = true,
		[159439] = true,
		[164331] = true,
		[163409] = true,
		[163413] = true,
		[161772] = true,
		[162284] = true,
		[158701] = true,
		[155118] = true,
		[159725] = true,
		[164332] = true,
		[163421] = true,
		[163422] = true,
		[159361] = true,
		[155252] = true,
		[158702] = true,
		[159214] = true,
		[159356] = true,
		[164333] = true,
		[163429] = true,
		[163430] = true,
		[163431] = true,
		[163437] = true,
		[158703] = true,
		[159215] = true,
		[163439] = true,
		[164334] = true,
		[163445] = true,
		[163446] = true,
		[163447] = true,
		[163449] = true,
		[158704] = true,
		[155121] = true,
		[163455] = true,
		[164335] = true,
		[154273] = true,
		[155228] = true,
		[155302] = true,
		[155305] = true,
		[158705] = true,
		[163960] = true,
}